AchievementDiscovery = class(Turbine.UI.Control)
function AchievementDiscovery:Constructor(handler)
    Turbine.UI.Control.Constructor(self)

    self.locations = {
        ["Annúminas"] = "Too Close for Comfort",
        ["Hrimbarg"] = "Mountain Maniac",
        ["Echad Candelleth"] = "Middle of Nowhere",
        ["Scout's Camp (Nan Tornaeth)"] = "Beware: Trolls",
        ["Echad Dúnann"] = "Knock on the Door",
        ["Echad Mirobel"] = "Ring Tourist",
        ["Aughaire"] = "Into the Shadow",
        ["Sûri-kylä"] = "Polar Explorer",
        ["Kuru-leiri"] = "Arctic Explorer",
    }

    self.locationsBackwards = {
        ["Too Close for Comfort"] = "Annúminas",
        ["Middle of Nowhere"] = "Echad Candelleth",
        ["Beware: Trolls"] = "Scout's Camp (Nan Tornaeth)",
        ["Ring Tourist"] = "Echad Mirobel",
        ["Knock on the Door"] = "Echad Dúnann",
        ["Mountain Maniac"] = "Hrimbarg",
        ["Into the Shadow"] = "Aughaire",
        ["Polar Explorer"] = "Sûri-kylä",
        ["Arctic Explorer"] = "Kuru-leiri",
    }

    self.handler = handler

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()

    self.discoveryCallback = AddCallback(ChatEventHandler, "Standard", function(args)
        if self.player:GetLevel() > 10 then return end
        local location = string.match(args, "You discovered the (.*) %- Swift Travel travel location.")
        if location == nil then
            location = string.match(args, "You discovered the (.*) travel location.")
        end

        if self.locations[location] then
            handler:AchievementAchieved(handler:NameToID(self.locations[location]))

            local data = handler:GetCharacterData()

            local achievements = handler:GetAchievementData()
            local count = 0
            for key, value in pairs(data.Achievements_Done) do

                if self.locationsBackwards[achievements[key].Title] then
                    count = count + 1
                end
            end

            if count == PrimeUtils.Utils.Tablelength(self.locations) then
                handler:AchievementAchieved(handler:NameToID("Road to Glory"))
            end
        end
    end)
end

function AchievementDiscovery:Unload()
    RemoveCallback(ChatEventHandler, "Standard", self.sneakCallback)
end